#include <Arduino.h>

void setup() {
  Serial.begin(115200);
  delay(1000); // Attente pour laisser le temps au port série de s'initialiser

  // Récupération de l'identifiant unique (64 bits)
  uint64_t chipid = ESP.getEfuseMac();

  // Réduction à 32 bits (optionnel, mais pratique pour un ID plus court)
  uint32_t sensor_id = (uint32_t)(chipid >> 32) ^ (uint32_t)chipid;

  // Affichage
  Serial.println();
  Serial.println("=== Identifiant unique de l'ESP32 ===");
  Serial.printf("ChipID (64 bits hex) : %04X%08X\n", (uint32_t)(chipid >> 32), (uint32_t)chipid);
  Serial.printf("Sensor ID (32 bits)  : %u\n", sensor_id);
  Serial.printf("X-Sensor             : esp32-%u\n", sensor_id);
  Serial.println("======================================");
}

void loop() {
  Serial.begin(115200);
  delay(1000); // Attente pour laisser le temps au port série de s'initialiser

  // Récupération de l'identifiant unique (64 bits)
  uint64_t chipid = ESP.getEfuseMac();

  // Réduction à 32 bits (optionnel, mais pratique pour un ID plus court)
  uint32_t sensor_id = (uint32_t)(chipid >> 32) ^ (uint32_t)chipid;

  // Affichage
  Serial.println();
  Serial.println("=== Identifiant unique de l'ESP32 ===");
  Serial.printf("ChipID (64 bits hex) : %04X%08X\n", (uint32_t)(chipid >> 32), (uint32_t)chipid);
  Serial.printf("Sensor ID (32 bits)  : %u\n", sensor_id);
  Serial.printf("X-Sensor             : esp32-%u\n", sensor_id);
  Serial.println("======================================");
}

