#include <Arduino.h>
#include <SoftwareSerial.h>

#define LORA_RX 13  // 
#define LORA_TX 2  // 

SoftwareSerial LoRaSerial(LORA_RX, LORA_TX); // SoftwareSerial pour LoRa-E5

void setup() {
    Serial.begin(115200);         // Moniteur série (PC)
    LoRaSerial.begin(9600);       // Port série logiciel pour LoRa-E5

    delay(2000);
    Serial.println("Envoi de la commande AT pour obtenir le DevEui...");
    LoRaSerial.println("AT+ID=DevEui"); // Envoi de la commande
}

void loop() {
    if (LoRaSerial.available()) {
        String response = "";
        while (LoRaSerial.available()) {
            response += (char)LoRaSerial.read();
        }
        Serial.println("Réponse du LoRa-E5 : " + response);
    }
    delay(1000);
}
